#################################s#o#q######################################
## by Arthur Chan @ soqhome.com
#############################################################################

from AccessControl import ClassSecurityInfo
from Globals import InitializeClass, package_home
from OFS.SimpleItem import SimpleItem
#from Products.CMFCore.ActionProviderBase import ActionProviderBase
#from Products.CMFCore.ActionInformation import ActionInformation
from Products.CMFCore.CMFCorePermissions  import ManagePortal, ModifyPortalContent, View, SetOwnProperties
#from Products.CMFCore.Expression import Expression
from Products.CMFCore.utils import UniqueObject, getToolByName

from Products.CMFDocMgt import DocMgtRootPermissions
from Products.PageTemplates.PageTemplateFile import PageTemplateFile




from Products.CMFDocMgt.config import *

import calendar

from DateTime import DateTime

class CMFDocMgtTool(UniqueObject, SimpleItem):
    """ CMF Syndication Client  """

    id        = 'cmfdocmgt_tool'
    meta_type = 'CMFDocMgt Tool'
    security = ClassSecurityInfo()
    plone_tool = 1

    manage_options=(
        ({ 'label'   : 'Config',
           'action'  : 'manage_configForm',
           },
         ) + SimpleItem.manage_options
        )

    security.declareProtected( ManagePortal
                             , 'manage_configForm' )    
    
    manage_configForm = PageTemplateFile('www/config', globals(), __name__='manage_configForm')

    def __init__(self):
        self._reset()

    def _reset(self):
        ##### Portal Data #####
        
        self.CMFDOCMGT_ENABLE_SYNDICATION	= CMFDOCMGT_ENABLE_SYNDICATION
        self.FTPPort	= FTPPort
        self.LogUser	= LogUser
        
        self.BatchPageSize	= BatchPageSize
        self.DefaultContentType	= DefaultContentType
        
        
    def _set(self, REQUEST=None, **kwargs):
        if REQUEST==None:
            arglist= kwargs
        else:
            arglist = REQUEST
        
        
        self.CMFDOCMGT_ENABLE_SYNDICATION	= arglist['CMFDOCMGT_ENABLE_SYNDICATION']
        self.DefaultContentType	= arglist['DefaultContentType']
        self.FTPPort	= arglist['FTPPort']
        
        self.LogUser	= arglist['LogUser']
        
        self.BatchPageSize	= arglist['BatchPageSize']
        self.DefaultContentType	= arglist['DefaultContentType']
        
    security.declareProtected( DocMgtRootPermissions.ChangeRoot, 'manage_configdocmgt' )
    def manage_configdocmgt(self, submit, \
                         REQUEST=None, **kwargs):
        """config this puppy"""
        if submit == "Set Config":
            self._set(REQUEST=REQUEST, **kwargs)
        elif submit == "Reset Config":
            self._reset()

        if REQUEST:
            REQUEST['manage_tabs_message'] = 'Config+Updated'
            return REQUEST.RESPONSE.redirect(self.absolute_url() + \
                                             "/manage_configForm")



    #############################################################################
    ##                             Members                                     ##
    #############################################################################

    security.declareProtected(SetOwnProperties, 'moveMemberList')
    def moveMemberList(self, fromprop, toprop=''):
        ms = self.portal_membership
        user = ms.getAuthenticatedMember()
        names = self.REQUEST.get(fromprop, [])
        if type(names) == type('a'):
            names= [names]
        flist = user.getProperty(fromprop)
        for n in names:
            flist.remove(n)
        user.setMemberProperties({fromprop:flist})
        if toprop <>'':
            tlist = user.getProperty(toprop)
            for n in names:
                if n not in tlist:
                    tlist.append(n)
            user.setMemberProperties({toprop:tlist})
        #return flist + ['xxx'] + [type(self.REQUEST.get(fromprop, []))] + [ type('a')] + ['yyy'] + [user.getUserName()]
        
InitializeClass(CMFDocMgtTool)
