#################################s#o#q######################################
## by Arthur Chan @ soqhome.com
#############################################################################

from AccessControl import ClassSecurityInfo

from Globals import package_home

from Products.CMFCore import CMFCorePermissions
from Products.CMFCore.PortalContent import PortalContent
from Products.CMFCore.WorkflowCore import WorkflowAction
from Products.CMFDefault.DublinCore import DefaultDublinCoreImpl
from Products.CMFDefault.File import File

from AccessControl import getSecurityManager, SpecialUsers

from zLOG import LOG, WARNING, BLATHER, INFO

from Acquisition import aq_base, aq_parent, aq_inner, aq_chain



from Products.CMFDocMgt import DocMgtFilePermissions

from OFS.ObjectManager import ObjectManager

from DateTime.DateTime import DateTime
from Globals import InitializeClass

#import mimetypes

from cStringIO import StringIO

from OFS.content_types import guess_content_type

import os, os.path, string, types, urllib, mimetypes, sys
import OFS

DOC_ICONS_FILE = package_home(globals()) + '/data/doc_icons.props'      

factory_type_information = ( { 'id'             : 'DocMgtFile'
                             , 'meta_type'      : 'DocMgtFile'
                             , 'description'    : """\
DocMgtFile can hold arbitrary binary data."""
                             , 'icon'           : 'file_icon.gif'
                             , 'product'        : 'CMFDocMgt'
                             , 'factory'        : 'addDocMgtFile'
                             , 'immediate_view' : 'docmgtfile_edit_form'
                             , 'global_allow' : 0
                             , 'allow_discussion' : 1
                             , 'actions'        :
                                ( { 'id'            : 'view'
                                  , 'name'          : 'View'
                                  , 'action'        : 'docmgtfile_view'
                                  , 'permissions'   : (
                                      CMFCorePermissions.View, )
                                  }
                                , { 'id'            : 'edit'
                                  , 'name'          : 'Edit'
                                  , 'action'        : 'docmgtfile_edit_form'
                                  , 'permissions'   : (
                                      DocMgtFilePermissions.ChangeFile, )
                                  }
                                )
                             }
                           ,
                           )

def addDocMgtFile( self
           , id=''
           , title=''
           , file=''
           , precondition=''
           ):
    self=self.this()
    if title=='':
        title=id
    bnNew = hasattr(self, id)
    
    fobj = DocMgtFile( id, title, file=file, precondition=precondition
               )
    
    portal_membership = self.portal_membership
    author = portal_membership.getAuthenticatedMember()
    
    fobj.manage_addProperty('author', author, 'string')
    # docstatus: 0=normal; 1=checkout; 2=approved;
    fobj.manage_addProperty('docstatus', '0', 'string')
    
    fobj.manage_addProperty('deadline', '2049/12/31', 'date')
    fobj.manage_addProperty('email', '', 'string')
    fobj.manage_addProperty('actionusr', '', 'string')
    fobj.manage_addProperty('actiondate', '1900/1/1', 'date')
    # Add the File instance to self
    #self.allowDiscussion = 1
    self._setObject(id, fobj)
    self._getOb(id).manage_upload(file)
    
    #obj = self.__of__()
    #newpath= self.getRevPath()
    #self.RevisionManager.add([newpath])
    

class DocMgtFile( File  ):
    meta_type='DocMgtFile'
    manage_options = File.manage_options

    security = ClassSecurityInfo()
    #global_allow = 0


    _doc_icons_map = {}

    def __init__( self
                , id
                , title=''
                , file=''
                , precondition=''
                ):
                
        if title=='':
            title=id            
        File.__init__( self
                       , id=id
                       , title=title
                       , file=file
                       , precondition=precondition)
        
        

    security.declarePrivate( '_initDocIcons' )        
    def _initDocIcons( self ):
        """
            Initialize Doc Icons Map
        """        
        f = open(DOC_ICONS_FILE, 'rb')
        lines = [line.strip().lower() for line in f.readlines()]
        
        icon_map = self.getDocIconsMap()
        
        for line in lines:
            if line.startswith('#' ): continue # comment
            
            try:
                name = line.split(':')[0].strip()
                icon = line.split(':')[1].strip()
            except:
                continue
            
            icon_map[name] = icon


    security.declarePublic( 'getIcon' )
    def getIcon( self, relative_to_portal=0 ):
        """
            Return icon depending on media type
        """
        
        return self.getDocIcon(name=self.get_content_type())

    security.declarePublic( 'get_content_type' )
    def get_content_type(self):
        return self.content_type
    

    security.declarePublic( 'getDocIconMap' )        
    def getDocIconsMap( self ):
        """
           Return the media icons map
        """
        
        return DocMgtFile._doc_icons_map
        
    security.declarePublic( 'getDocIcon' )        
    def getDocIcon( self, name ):
        """
           Return the requested document icon
        """
        
        icon_map = self.getDocIconsMap()
        
        if not len(icon_map ):
            self._initDocIcons()
            icon_map = self.getDocIconsMap()
        
        if icon_map.has_key(name ):
            return icon_map[name]

        return icon_map['etc']
       
    security.declareProtected( DocMgtFilePermissions.ChangeFile, 'edit' )
    def edit( self, title=None, description=None, precondition='', file='', \
        author=None, email=None, docstatus=None, actionusr=None, deadline='2049/12/31', content_type='', **kwag ):
        """
            Edit File
        """
        #LOG('CMFDocMgt', INFO, 'start editing %s ' % self.getId())
        
        self._check_lock()
        
        LOG('CMFDocMgt', INFO, 'parameter title: %s, content %s:' % (str(title), str(content_type)))
        
        oldsize= self.get_size()
        
        File.edit( self, precondition=precondition, file=file)
        LOG('CMFDocMgt', INFO, 'File.edit ct= %s' % str(self.content_type))
        
        
        self.author = author
        
        if email <> None:
            self.email = email
        elif kwag.has_key('email'):
            self.email = kwag['email']
        if docstatus <> None:
            self.docstatus = docstatus
        elif kwag.has_key('docstatus'):
            self.docstatus = kwag['docstatus']
        if actionusr <> None:
            self.actionusr = actionusr
        elif kwag.has_key('actionusr'):
            self.actionusr = kwag['actionusr']
        if deadline <> None:
            self.deadline = deadline
        elif kwag.has_key('deadline'):
            self.docstatus = kwag['deadline']
        
        if title <> None:
            self.setTitle(title)
        elif kwag.has_key('title'):
            self.setTitle = kwag['title']
        if description <> None:
            self.setDescription(description)
        elif kwag.has_key('description'):
            self.setDescription = kwag['description']
        
        if content_type <> '':
            self.content_type = content_type
            LOG('CMFDocMgt', INFO, 'has content_type 1 %s' % str(self.content_type))
        elif kwag.has_key('content_type'):
            self.content_type = kwag['content_type']
            LOG('CMFDocMgt', INFO, 'has content_type 2 %s' % str(self.content_type))
        elif file <> '':
            body, size = self._read_data(file)
            if type(body) is not type(''): body=body.data
            tool = self.cmfdocmgt_tool
            ct=guess_content_type(getattr(file, 'filename',self.getId()), body, getattr(self, 'content_type', tool.DefaultContentType))
            
            self.content_type  = ct[0]
            
            LOG('CMFDocMgt', INFO, 'has content_type 3 %s' % str(self.content_type))
            
        #body, size = self._read_data(file)
        #if type(body) is not type(''): body=body.data
        #ct=guess_content_type(getattr(file, 'filename',id), body, self.content_type)
    
        #LOG('CMFDocMgt', INFO, 'guest %s:, real %s, input %s: ' % (ct, self.content_type, content_type))
        
        #else:
        #    if file<>'':
        #        tmp = file.headers['Content-Type']
        #    if tmp == '':
        #        tmp = self.cmfdocmgt_tool.DefaultContentType #'application/octet-stream'
        #    self.content_type = tmp
            
        
        
        
        #LOG('CMFDocMgt', INFO, 'updated File ')
        norev=0
        if kwag.has_key('norev'):
            if kwag['norev'] ==1:
                norev=1
        if file <> '' and norev==0 :
        
            #revmgr = self.RevisionManager
            #newpath= self.getRevPath()
            if not self.REQUEST.get('MappingRM', 0):
                
                if oldsize == 0:
                    #LOG('CMFDocMgt', INFO, 'added in edit')
                    self.addRev()
                else:
                    
                    if kwag.has_key('log'):
                        log = kwag['log']
                    else:
                        log = 'New file content uploaded'
                    #LOG('CMFDocMgt', INFO, 'editing in edit %s' % log)
                    LOG('CMFDocMgt', INFO, 'before update ct= %s' % str(self.content_type))
                    self.updateRev(log)
                    LOG('CMFDocMgt', INFO, 'after update ct= %s' % str(self.content_type))
        


    security.declarePrivate('manage_afterAdd')
    def manage_afterAdd(self, item, container):
        #LOG('CMFDocMgt', INFO, 'after add called %s' % self.id)
        File.manage_afterAdd(self,item, container)
        
        self.addRev()
        #if self.get_size():
            #newpath= self.getRevPath()
            #self.RevisionManager.add([newpath])
            
            
            #container.setTitle(newpath)
            #self.RevisionManager.commit('system commit', [newpath])

    security.declarePrivate('manage_beforeDelete')
    def manage_beforeDelete(self, item, container):
        File.manage_beforeDelete(self,item, container)
        if self.get_size():
            self.removeRev()
        #if self.get_size():
        #    newpath= self.getRevPath()
        #    self.RevisionManager.remove([newpath])
            
            
        #self.RevisionManager.commit('system commit', [newpath])

    security.declarePrivate('manage_afterClone')
    def manage_afterClone(self, item):
        
        File.manage_afterClone(self,item)
        self.addRev()
        #if self.get_size():
        #    newpath= self.getRevPath()
        #    self.RevisionManager.add([newpath])
        #self.RevisionManager.commit('system commit', [oldpath, newpath])


    #############################################################################
    ##                             RevisionManager                             ##
    #############################################################################


    def findparent(object):
        """ find the direct parent """
    
        for parent in aq_chain(object):
            if parent is object:
                continue
            if parent == object:
                continue
            if isinstance(parent, ObjectManager):
                return parent
        return None    

    security.declarePublic( "logRev")
    def logRev(self, paths):
        revmgr = self.RevisionManager
        if not paths:
            return {}

        # write objects to FS
        #all_paths = self.addParentAndChildPaths(paths)
        #self.writeToFS(all_paths)

        if revmgr._settings['save_properties']:
            file_paths = paths
            for abs_filename in file_paths :
                basename = os.path.basename(abs_filename)
                dirname = os.path.dirname(abs_filename)
                prop_path = os.path.join(dirname, "." + basename + '.properties')
                    
                if os.path.isfile(prop_path):
                    paths = paths.append(prop_path)
                    

        
            #paths = revmgr.addPropertyPaths(paths)
        paths = revmgr._escape_spaces(paths)

        # retrieve cvs log information
        cvs = revmgr._get_wrapper()
        revmgr.clearLazyTraverse()
        return cvs.log(" ".join(paths))

    security.declareProtected( DocMgtFilePermissions.ChangeFile, 'updateRev' )
    def updateRev( self, log):
        if self.get_size():
            revmgr = self.getRM()
            newpath= self.getRevPath()
            revmgr.status([newpath])
            
            #cvs = revmgr._get_wrapper()
            
            revmgr.update([newpath], tag='', reset_sticky=1)
            
            #cvs.update(newpath, reset_sticky=1)
            #LOG('CMFDocMgt', INFO, 'reset sticky for %s ' % newpath)
            #def update(self, filename="", tag="", recursive=1, prune_empty=0,
            #   new_dirs=0, reset_sticky=0):
            tool = self.cmfdocmgt_tool
            if tool.LogUser:
                author = self.portal_membership.getAuthenticatedMember().getUserName()
                log = '[' + author + ']' + log
            revmgr.commit(log, [newpath])
            
            #LOG('CMFDocMgt', INFO, 'Updated the revision for %s ' % newpath)

    security.declarePrivate('addRev')
    def addRev( self ):
            
        if self.get_size():
            revmgr = self.getRM()
            newpath= self.getRevPath()
        
            LOG('CMFDocMgt', INFO, 'Adding new revision for %s ' % newpath)
            
            revmgr.add([newpath])
            
            LOG('CMFDocMgt', INFO, 'Added new revision for %s ' % newpath)
            
        #else:
        #    revmgr = self.getRM()
        #    newpath= self.getRevPath()
        #    revmgr.status([newpath])
        #    log = "Modified By RevisionManager"
        #    revmgr.commit(log, [newpath])
    
    security.declarePrivate('removeRev')
    def removeRev( self ):
        if self.get_size():
            revmgr = self.getRM()
            newpath= self.getRevPath()
            revmgr.remove([newpath])
            #LOG('CMFDocMgt', INFO, 'Removed the revision for %s ' % newpath)

    def getRM(self):
        #paths = self.getPhysicalPath()
        #lp = len(paths)
        #found = None
        
        parent = self
        
        while not hasattr(aq_base(parent), 'RevisionManager'):
            #LOG('CMFDocMgt', INFO, 'Finding parent for %s ' % parent.id)
            parent = parent.findparent()
            #LOG('CMFDocMgt', INFO, 'The parent is %s ' % parent.id)
            
        return parent['RevisionManager']
        
        
#        for i in range(lp):
#            temp = self.restrictedTraverse(paths[:lp - i - 1])
#            if hasattr(aq_base(temp),'RevisionManager'):
#                found = temp
#        if found <> None:
#            return found['RevisionManager'] #self.restrictedTraverse(found['RevisionManager'].getPhysicalPath())

    def getRMParent(self):
        parent = self
        while not hasattr(aq_base(parent), 'RevisionManager'):
            parent = parent.findparent()
        
        
        return parent
        
    def getRevPath(self):
        paths = self.getPhysicalPath()
        rmp = self.getRMParent()
        if rmp:
            return '/'.join(paths[len(rmp.getPhysicalPath()):])

    #def getRevPath(self):
    #    parent= self.aq_parent
    #    while not parent.isPrincipiaFolderish:
    #        parent= parent.aq_parent
    #    
    #    #test = parent.absolute_url()
    #    portal_url = parent.portal_url
    #    #portal = self.aq_inner.aq_parent
    #    
    #    paths = string.split(portal_url.getRelativeUrl(parent) + '/' +  self.getId(), '/')
    #            
    #    #newpath= string.join(paths[len(paths):], '/')
    #    
    #    #pos = len(paths)-1
    #    
    #    #newpath = string.join(paths, '/') #string.join(paths[index:], '/')
    #    
    #    #newpath = string.join(paths[index:], '/')
    #    #temp.getId()
    #    
    #    
    #    base = portal_url.getPortalObject()
    #    #if (not hasattr(temp.aq_explicit, 'RevisionManager')) and temp <> base:
    #    #    temp = temp.aq_parent
    #    #tes=0
    #    #test = '['
    #    while not getattr(aq_base(parent), 'RevisionManager', None) : #and temp <> base:
    #        #pos = pos - 1
    #        #test = test + ', ' + parent.absolute_url()
    #        #tes=tes + 1
    #        parent = parent.aq_parent
    #    #test = test + ']'
    #    
    #    p = string.split(portal_url.getRelativeUrl(parent), '/')
    #    pos = 0
    #    for i in range(len(p)):
    #        pos =pos + 1
    #        
    #    #newpath =  str(len(p)) + ' ' + str(pos)  + '###' + parent.absolute_url() +'###' + string.join(paths, '/') + '###' + str(pos)  + '###' +str(tes) 
    #    newpath = string.join(paths[pos:], '/')                   
    #    return newpath

#def getRevPath(self):
#        temp = self
#        portal_url = self.portal_url
#        
#        temp = portal_url.restrictedTraverse(portal_url.getRelativeUrl(self))
#        paths= string.split(portal_url.getRelativeUrl(temp), '/')
#        
#        revmgr = getattr(self, 'RevisionManager', None)
#        if revmgr ==None:
#            return '1' # None
#            
#        revmgr = portal_url.restrictedTraverse(revmgr.aq_explicit.absolute_url('relative'))
#        
#        rootpaths = string.split(portal_url.getRelativeUrl(revmgr.aq_parent), '/')
#        
#        for i in range(len(rootpaths)):
#            if rootpaths[i]<>paths[i]:
#                #return None	# error occurs here
#                return '2' + string.join(paths, '/')	+ string.join(paths, '/') 
#                
#        newpath= string.join(paths[len(rootpaths):], '/')
#        
#        #index = len(paths)
#        ##newpath = string.join(paths[index:], '/')
#        ##temp.getId()
#        #
#        #
#        #base = portal_url.getPortalObject()
#        ##if (not hasattr(temp.aq_explicit, 'RevisionManager')) and temp <> base:
#        ##    temp = temp.aq_parent
#        #while (not hasattr(temp.aq_explicit, 'RevisionManager')) : #and temp <> base:
#        #    index = index -1
#        #    #newpath = temp.getId() + '/' + newpath
#        #    newpath = string.join(paths[index:], '/')
#        #    temp = temp.aq_parent
#        return '3' + newpath

    #def getPropertyValue( self, name, properties='' ):
    #    """
    #    Get the property Value
    #    """
    #
    #    if properties:
    #        pa = properties.split('\n')
    #        for i in range(len(pa)):
    #            try:
    #                tmp= pa[i].split('=')
    #                key = tmp[0]
    #                value=tmp[1]
    #                if key[:len(name)+1]==name + ':':
    #                    return value
    #            except:
    #                continue
    #        
    #def getPropertyRev( self, logprop, revdate):
    #    """
    #    Try to get the property rev tag which has the smallest date difference from the file rev
    #    """
    #    if logprop ==None:
    #        return
    #        
    #    revisions = logprop['revisions']
    #    diff = -1
    #    rdate = float(revdate)
    #    ret = ''
    #    for rev in revisions:
    #        tmp = abs(rdate - rev['date'] )
    #        if tmp < diff or diff == -1:
    #            ret = rev['revision']
    #            diff = tmp
    #    return ret
        
        
        
    #    obj_status = revmgr.getStatus(path)
    #    data = File.manage_FTPget(self)
    #    #if obj_last_modified < obj_status.get('zodb_last_modified', 0.0):
    #    #    data  = self.downloadRev(reqrev='', REQUEST=request, RESPONSE=response)
    #    #else:
    #    #    data = File.manage_FTPget(self)
    
            
    
    
    security.declareProtected( DocMgtFilePermissions.ChangeFile, 'checkOut' )
    def checkOut(self, REQUEST, RESPONSE):
        self.manage_changeProperties({'docstatus':'1',
									'actionusr': str(REQUEST.AUTHENTICATED_USER),
									'actiondate': DateTime()
									})

    security.declareProtected( DocMgtFilePermissions.ChangeFile, 'checkIn' )
    def checkIn(self, file, log='', precondition='', REQUEST=None, RESPONSE=None):
        author = self.portal_membership.getAuthenticatedMember().getUserName()
        #self.manage_changeProperties({'docstatus':'0',
	#								'actionusr': author
	#								})
	
        #logmsg = '%s|\~%s|\~%s'%(str(REQUEST.AUTHENTICATED_USER ),email, log)
        #def edit( self, title=None, description=None, precondition='', file='', author=None, email=None, docstatus=None, deadline='2049/12/31', content_type='', **kwag ):
        
        #LOG('CMFDocMgt', INFO, 'editing %s ' % (self.getId()))
        
        self.edit(precondition=precondition, file=file, docstatus='0', log=log)
        #LOG('CMFDocMgt', INFO, 'finished %s ' % (self.getId()))
        #LOG('CMFDocMgt', INFO, 'finished ' % (self.getId()))
        
        #File.edit( self, precondition=precondition, file=file)
        #sgPath= self.getRevPath()
        #self.updateRev(log)
        
        #revmgr = self.RevisionManager
        #revmgr.status([sgPath])
        #revmgr.commit(log, [sgPath])
        
    security.declareProtected( DocMgtFilePermissions.ChangeFile, 'approve' )
    def approve(self, REQUEST, RESPONSE):
        self.manage_changeProperties({'docstatus':'2',
									'actionusr': str(REQUEST.AUTHENTICATED_USER),
									'actiondate': DateTime()
									})
        #RESPONSE.redirect(self.aq_parent.absolute_url()+'/view')

    security.declareProtected( DocMgtFilePermissions.ChangeFile, 'undoaction' )
    def undoaction(self, REQUEST, RESPONSE):
        self.manage_changeProperties({'docstatus':'0',
									'actionusr': ''
									})
        #RESPONSE.redirect(self.aq_parent.absolute_url()+'/view')
    
    def retrieve(self, filename="", tag="", recursive=1, prune_empty=0,pipe=0,
               new_dirs=0, reset_sticky=0):
        """
        perform a CVS update
        """
        
        
        cvs = self.RevisionManager._get_wrapper()
        
        cvs._prepare()
        cmdopt = ""
        if not recursive:
            cmdopt += "-l"
        if prune_empty:
            cmdopt += " -P"
        if pipe:
            cmdopt += " -p"
        if new_dirs:
            cmdopt += " -d"
        if reset_sticky:
            cmdopt += " -A"
        if tag:
            cmdopt = "-r %s %s" % (tag, cmdopt)
        result_val, result_out, result_err = \
                    cvs._exec_cmd("update", "", cmdopt, filename)
        cvs._clean_up()

        # updatedict = cvs.parse_listout(result_out)
        # updatedict.update(cvs.parse_update_removed(result_err))
        
        #****cvs update -A
        return result_out        
    

    security.declareProtected( CMFCorePermissions.View, 'downloadRev' )
    def downloadRev(self, reqrev='', REQUEST=None, RESPONSE=None):
        sg = ''
        sgPath= self.getRevPath()
        lastrev = self.getLastRevNo()
        if reqrev =='':
            reqrev = lastrev
        else:
            sg = '.' + reqrev
        sg = sg.replace('.', '_')
        contentExt = self.getContentExtension()
        revmgr = self.RevisionManager
        
        #revmgr.update([sgPath], tag=reqrev, reset_sticky=1)
        
        paths=[sgPath]
        settings = revmgr._settings
        #if settings['save_properties']:
        #    paths = revmgr.addPropertyPaths(paths)
        escaped_paths = revmgr._escape_spaces(paths)
        
        
        #abs_filename = revmgr.getAbsoluteFilePath(sgPath)
        data = self.retrieve(filename=" ".join(escaped_paths), tag=reqrev, pipe=1, reset_sticky=1)
        #data = self.retrieve(filename=[sgPath], tag=reqrev, pipe=1)

        #abs_filename = revmgr.getAbsoluteFilePath(sgPath)
        #data = open(abs_filename, "rb").read()
        
        #revmgr.update([sgPath], reset_sticky=1)
        
        #data = File.download(self, REQUEST, RESPONSE)
        RESPONSE.setHeader('Content-Type', 'application/download')
        RESPONSE.setHeader('Content-Length', len(data))
        
        filename=self.getId()
        if filename[len(filename) - len(contentExt):] == contentExt:
            filename=filename[:len(filename) - len(contentExt)]
        
        filename=filename+ sg 
        filename=filename + contentExt
        
        RESPONSE.setHeader('Content-Disposition', 'attachment; filename=%s' % (filename))

        #LOG('CMFDocMgt', INFO, '%d, %d, [%s]' %(len(self.getId()) , len(contentExt), self.getId()[:len(self.getId()) - len(contentExt)]))
        return  data


        
    security.declarePrivate('getLastRevNo')
    def getLastRevNo(self):
        sgSrcRevPath = self.getRevPath()
        paths = [sgSrcRevPath]
        revmgr = self.RevisionManager
        #log = revmgr.log(paths)
        cvs = revmgr._get_wrapper()
        revmgr.clearLazyTraverse()
        log = cvs.log(" ".join(paths))
        
        filenames = log.keys()
        lastrev = ''
        lastrevdate = ''
        for f in paths:
        	log_info = log[f]
        	for rev in log_info['revisions']:
        		moddate = rev['date'] #.strftime('%Y-%m-%d %I:%M:%S %p')
       			if lastrevdate < moddate :
       				lastrevdate = moddate
       				lastrev = rev['revision']
        return lastrev

    security.declarePrivate('getContentExtension')
    def getContentExtension(self):
        contenttype = self.content_type
        ext = mimetypes.guess_extension(contenttype)
        
#        ret = ''
#        contenttype = self.content_type
#        if contenttype in ('application/msword', 'text/richtext'):
#        	ret = 'doc'
#        elif contenttype=='application/vnd.ms-excel':
#        	ret = 'xls'
#        elif contenttype=='application/pdf':
#        	ret = 'pdf'
#        elif contenttype=='application/vnd.ms-powerpoint':
#        	ret = 'ppt'
#        elif contenttype=='application/x-zip-compressed':
#        	ret = 'zip'
#        elif contenttype=='audio/wav':
#        	ret = 'wav'
#        elif contenttype=='application/vnd.rn-realmedia':
#        	ret = 'rm'
#        elif contenttype=='video/x-ms-wmv':
#        	ret = 'wmv'
#        elif contenttype=='video/mpeg':
#        	ret = 'mpeg'
#        elif contenttype=='text/html':
#        	ret = 'html'
#        elif contenttype=='text/plain':
#        	ret = 'txt'
#        elif contenttype=='image/x-png':
#        	ret = 'png'
#        elif contenttype=='image/gif':
#        	ret = 'gif'
#        elif contenttype=='image/pjpeg':
#        	ret = 'jpg'
#        elif contenttype=='audio/x-ms-wma':
#        	ret = 'wma'
#        elif contenttype=='audio/x-pn-realaudio':
#        	ret = 'rm'
#        elif contenttype=='application/x-shockwave-flash':
#        	ret = 'swf'
#        else:
#        	if contenttype.find('text') > -1:
#        		ret = 'txt'
#        	elif contenttype=='application/octet-stream':
#        		ret = self.cmfdocmgt_tool.DefaultFileExtension #'dat'	#default file type
#        
        return ext



    def _check_lock(self):
        """ Check if the file is locked """
        emergency = 0
        user=getSecurityManager().getUser()
        
        if (SpecialUsers.emergency_user and
            aq_base(user) is SpecialUsers.emergency_user):
            emergency = 1
        
        docstatus = str(getattr(self, 'docstatus', '0')) 
        actionusr = str(getattr(self, 'actionusr', '')) 
        username = user.getUserName()
        if not emergency:
            if docstatus == '1' and \
                username <> actionusr and actionusr <> '':
           
                raise CMFDocMgtLockException, \
                  "This file is locked by %s. Document status is %s (Not normal)" + \
                  (username, docstatus)

            if docstatus >= '2':
           
                raise CMFDocMgtLockException, \
                  "This file is in approved state, you cannot update it."
        

    #############################################################################
    ##                             Syndication                                 ##
    #############################################################################

    security.declareProtected( CMFCorePermissions.View, 'queryCatalog' )
    def queryCatalog( self, REQUEST=None, **kw ):
        query = {'path': self.absolute_url('relative'),
                'meta_type' :['DocMgtFile'],
                }

        kw.update(query )
        return apply( self.portal_catalog.searchResults, ( REQUEST, ), kw )


    security.declarePublic('synContentValues')
    def synContentValues(self):
        """ play nice with portal_syndication_tool"""
        return self.queryCatalog()
        
    #############################################################################
    ##                             FTP                                         ##
    #############################################################################




    #security.declareProtected(CMFCorePermissions.View, 'manage_FTPget')
    #def manage_FTPget(self):
    #    #""" Handle HTTP (and presumably FTP?) PUT requests """
    #    request = self.REQUEST
    #    response = request.RESPONSE
    #    #self._check_lock()
    #    # don't write if it wasn't modified
    #    obj_last_modified = float(self.bobobase_modification_time())
    #    revmgr = self.getRM()
    #    path= self.getRevPath()
    #    obj_status = revmgr.getStatus(path)
    #    data = File.manage_FTPget(self)
    #    #if obj_last_modified < obj_status.get('zodb_last_modified', 0.0):
    #    #    data  = self.downloadRev(reqrev='', REQUEST=request, RESPONSE=response)
    #    #else:
    #    #    data = File.manage_FTPget(self)
    #    return data

    security.declareProtected(CMFCorePermissions.ModifyPortalContent, 'PUT')
    def PUT(self, REQUEST, RESPONSE):
        """ Handle HTTP (and presumably FTP?) PUT requests """
        parent = self.findparent()
        if not parent:
            #LOG('CMFDocMgt', INFO, '%s is a new file, and PUT_factory has handled the ftp process' % (self.getId()))
            return
        else:
            #LOG('CMFDocMgt', INFO, 'FTP uploading file in DocMgtFile.py %s ' % self.getId())
            
            file=REQUEST['BODYFILE']
            
            if file<>'':
                #type=REQUEST.get_header('content-type', None)
                #data, size = self._read_data(file)
                #content_type=self._get_content_type(file, data, self.__name__,
                #                            type or self.content_type)
                log = 'FTP uploaded content'
                self.edit(file=file, docstatus='0', log=log)
            
            #File.PUT( self, REQUEST, RESPONSE )
            
            
            #size= self.get_size()
            #if size >0:
            #
            #    #revmgr.status([newpath])
            #    log = 'FTP uploaded content'
            #    
            #    self.updateRev(log)
            #    
            #    #LOG('CMFDocMgt', INFO, 'File uploaded successfully')
            
InitializeClass(DocMgtFile)



