#################################s#o#q######################################
## by Arthur Chan @ soqhome.com
#############################################################################

from Products.CMFDocMgt import DocMgtFolderPermissions

from Products.CMFCore import CMFCorePermissions
from Products.CMFCore.utils import _checkPermission, _getViewFor,getToolByName
#from Products.CMFCore.PortalFolder import PortalFolder
from Products.CMFPlone.PloneFolder import PloneFolder
from zLOG import LOG, WARNING, BLATHER, INFO

from Globals import HTMLFile, package_home, InitializeClass
from AccessControl import Permissions, ClassSecurityInfo
from Acquisition import aq_parent, aq_inner, aq_base, aq_chain
from ComputedAttribute import ComputedAttribute

from OFS.ObjectManager import ObjectManager
import os

# Factory type information -- (for portal_types )
factory_type_information = \
( { 'id'                : 'DocMgtFolder'
  , 'content_icon'      : 'folder_icon.gif'
  , 'meta_type'         : 'DocMgtFolder'
  , 'description'       : 'DocMgtFolder is for storing objects'
                          'which will be stored in CVS.'
  , 'global_allow' : 0
  , 'product'           : 'CMFDocMgt'
  , 'factory'           : 'addDocMgtFolder'
  , 'immediate_view'    : 'docmgtfolder_edit_form'
  , 'allowed_content_types'    : ('DocMgtFolder', 'DocMgtFile',)
  , 'actions'           :
    ( { 'id'            : 'view'
      , 'name'          : 'View'
      , 'action'        : 'docmgtfolder_view'
      , 'permissions'   : (CMFCorePermissions.View, )
      }
    , { 'id'            : 'edit'
      , 'name'          : 'Edit'
      , 'action'        : 'docmgtfolder_edit_form'
      , 'permissions'   : (DocMgtFolderPermissions.ChangeFolder, )
      }
#    , { 'id'            : 'local_roles'
#      , 'name'          : 'Local Roles'
#      , 'action'        : 'folder_localrole_form'
#      , 'permissions'   : (DocMgtFolderPermissions.ChangeFolder,)
#      , 'visible':1
#      , 'category'	  : 'object'
#      }
#    , { 'id'            : 'batchftp'
#      , 'name'          : 'Batch'
#      , 'action'        : 'batchftp'
#      , 'permissions'   : (DocMgtFolderPermissions.AddFolder,)
#      , 'visible':1
#      , 'category'	  : 'object'
#      }
    , { 'id'            : 'myfiles'
      , 'name'          : 'My Files'
      , 'action'        : 'myfiles'
      , 'permissions'   : (CMFCorePermissions.View,)
      , 'visible':1
      , 'category'	  : 'object'
      }
    )
  }
,
)

def addDocMgtFolder( self, id, title='', REQUEST=None ):
    folder = DocMgtFolder( id )
    folder.id = id
    folder.title = title
    portal_membership = self.portal_membership
    author = portal_membership.getAuthenticatedMember()
    
    folder.manage_addProperty('author', author, 'string')
#    # docstatus: 0=normal; 1=checkout; 2=approved;
#    folder.manage_addProperty('docstatus', 0, 'string')
    folder.manage_addProperty('deadline', '2049/12/31', 'date')
    folder.manage_addProperty('email', '', 'string')
    
    self._setObject( id, folder )

    if REQUEST is not None:
        REQUEST['RESPONSE'].redirect( 'manage_main' )


class DocMgtFolder( PloneFolder):
    
    meta_type='DocMgtFolder'

    security = ClassSecurityInfo()

    security.declareObjectProtected( CMFCorePermissions.View )

    _criteriaTypes = []
    
    #global_allow = 0

    # Contentish interface methods
    # ----------------------------

    security.declareProtected( CMFCorePermissions.View, 'icon' )
    def icon( self ):
        """
            For the ZMI.
        """
        return self.getIcon()

    security.declarePrivate( '_verifyActionPermissions' )
    def _verifyActionPermissions( self, action ):
        pp = action.get( 'permissions', () )
        if not pp:
            return 1
        for p in pp:
            if _checkPermission( p, self ):
                return 1
        return 0

    #def __call__( self ):
    #    """
    #        Invoke the default action.
    #    """
    #    view = _getViewFor( self )
    #    if getattr( aq_base( view ), 'isDocTemp', 0 ):
    #        return apply( view, ( self, self.REQUEST ) )
    #    else:
    #        return view()
    #
    #security.declarePublic( 'folder_contents' )
    #def folder_contents( self, REQUEST=None, RESPONSE=None, **kw ):
    #    """
    #        Return contents view
    #    """
    #    
    #    if REQUEST is None:
    #        REQUEST = self.REQUEST
    #          
    #    view = self.docmgtfolder_view
    #    if getattr(aq_base(view), 'isDocTemp', 0):
    #        return apply(view, ( self, REQUEST  ) )
    #    else:
    #        return view()        
    #
    #security.declarePublic( 'folder_listing' )
    #def folder_listing( self, REQUEST=None, RESPONSE=None, **kw ):
    #    """
    #        Return view
    #    """
    #    
    #    if REQUEST is None:
    #        REQUEST = self.REQUEST
    #          
    #    view = self.docmgtfolder_view
    #    if getattr(aq_base(view), 'isDocTemp', 0):
    #        return apply(view, ( self, REQUEST  ) )
    #    else:
    #        return view()       
    #
    #index_html = None  # This special value informs ZPublisher to use __call__
    #
    #
    #security.declareProtected( CMFCorePermissions.View, 'view' )
    #def view( self ):
    #    """
    #        Return the default view even if index_html is overridden.
    #    """
    #    return self()


    security.declareProtected( DocMgtFolderPermissions.ChangeFolder, 'edit' )
    def edit( self, title=None, description=None, author=None, email=None, deadline='2049/12/31' ):
    #def edit( self, title=None, description=None, author=None, email=None, docstatus=None, deadline='2049/12/31' ):
        self.setTitle(title)
        self.setDescription(description)
        self.author = author
        self.email = email
        #if docstatus <> None:
        #    self.docstatus = docstatus
        self.deadline = deadline


    def findparent(object):
        """ find the direct parent """
    
        for parent in aq_chain(object):
            if parent is object:
                continue
            if parent == object:
                continue
            if isinstance(parent, ObjectManager):
                return parent
        return None    


    #############################################################################
    ##                             Syndication                                 ##
    #############################################################################

    security.declareProtected( CMFCorePermissions.View, 'queryCatalog' )
    def queryCatalog( self, REQUEST=None, **kw ):
        query = {'path': self.absolute_url('relative'),
                'meta_type' :['DocMgtFile'],
                }

        kw.update(query )
        return apply( self.portal_catalog.searchResults, ( REQUEST, ), kw )


    security.declarePublic('synContentValues')
    def synContentValues(self):
        """ play nice with portal_syndication_tool"""
        return self.queryCatalog()

    #############################################################################
    ##                       HTTP (and presumably FTP?) Request                ##
    #############################################################################

    def PUT_factory( self, name, typ, body ):
        """
            Dispatcher for PUT requests to non-existent IDs.  Returns
            an object of the appropriate type (or None, if we don't
            know what to do).
        """
        
        #LOG('CMFDocMgt', INFO, 'FTP uploading file in %s, new file is %s ' % (self.getId(), name))
        
        registry = getToolByName( self, 'content_type_registry' )
        if registry is None:
            return None

        typeObjectName = registry.findTypeName( name, typ, body )
        if typeObjectName is None:
            return None
        #bnHasDocAlready = 0
        if typeObjectName in ['File', 'Image', 'Document']:
            typeObjectName = 'DocMgtFile'
            #bnHasObjAlready = hasattr(self, name)
        
        
        
        
        self.invokeFactory( typeObjectName, name )
        
        #log = 'New file content uploaded via FTP'
        
        # "refill" the created file content
        self[name].edit(file=body, content_type=typ, norev=1)
        
        #obj = self[name]
        
        #LOG('CMFDocMgt', INFO, 'Created %s, id is %s ' % (typeObjectName, name))
        
        # XXX: this is butt-ugly.
        obj = aq_base( self._getOb( name ) )
        
        #if bnHasDocAlready:
        #    log = 'New file content uploaded via FTP'
        #    self._getOb( name ).updateRev(log)
        
        self._delObject( name )
        
            
        #LOG('CMFDocMgt', INFO, 'File uploaded successfully after delete')
        
        return obj
        
InitializeClass( DocMgtFolder )
