#################################s#o#q######################################
## by Arthur Chan @ soqhome.com
#############################################################################

from Globals import package_home
from cStringIO import StringIO

from Products.CMFCore.DirectoryView import addDirectoryViews
from Products.CMFCore.TypesTool import ContentFactoryMetadata
from Products.CMFCore.utils import getToolByName, ToolInit



import os, re, sys

#####################################CMFDocMgt Permission ################################################
from Products.CMFDocMgt.DocMgtRootPermissions import AddRoot, ChangeRoot
from Products.CMFDocMgt.DocMgtFolderPermissions import AddFolder, ChangeFolder
from Products.CMFDocMgt.DocMgtFilePermissions import AddFile, ChangeFile

from Products.CMFDocMgt import factory_type_information
from Products.CMFDocMgt.config import *

#####################################CMFDocMgt Permission ################################################



def install_tools(self, out):
    portal_url = getToolByName(self, 'portal_url')
    p = portal_url.getPortalObject()
    if not hasattr(p, "cmfdocmgt_tool"):
        x = p.manage_addProduct['CMFDocMgt'].manage_addTool(type="CMFDocMgt Tool")
        print >>out, "Install Tool okay"
    else:
        print >>out, "Tool already exists."

def install( self ):

    
    out = StringIO()
    
    out.write('Start Installation\n')
    
    types_tool = getToolByName( self, 'portal_types')

    for fti in factory_type_information:
        if hasattr(types_tool, fti['id'] ):
            t = types_tool._getOb(fti['id'])
            if t.product == 'CMFDocMgt':
                types_tool._delObject(fti['id'])
            else:
                out.write("Types tool has a non-CMFDocMgt Content type with the id '%s'...\n" % fti['id'])
                continue
    
        cfm = apply(ContentFactoryMetadata, (), fti)
        types_tool._setObject(fti['id'], cfm)
                       
        out.write("Registered CMFDocMgt Content type '%s' with the types tool...\n" % fti['id'])                

    skins_tool = getToolByName( self, 'portal_skins')

    skins = skins_tool.getSkinSelections()
    for skin in skins:
        path=[elem.strip() for elem in skins_tool.getSkinPath(skin).split(',')]        
        for n_skin in ['soq_docmgt']:
            if n_skin not in path:
                try:
                    path.insert( path.index('custom') + 1, n_skin )
                except:
                    path.append( n_skin )

        path = ', '.join( path )                
        skins_tool.addSkinSelection(skin, path)

    if 'soq_docmgt' not in skins_tool.objectIds( ):
        addDirectoryViews(skins_tool, 'skins', docmgt_globals)

    out.write("Added CMFDocMgt Skins to %s skins\n" % skin)


    # add portal navigation properties from data/navigation_properties
        
    nav_tool = getToolByName( self, 'portal_navigation')

    # open and parse the file
    filename='navigation_properties'
    src_file =  open(os.path.join(package_home(docmgt_globals), 'data', filename), 'r')
    src_lines = src_file.readlines()
    src_file.close(); 
    
    re_comment = re.compile(r"\s*#")
    re_blank = re.compile(r"\s*\n")
    re_transition = re.compile(r"\s*(?P<type>[^\.]*)\.(?P<page>[^\.]*)\.(?P<outcome>[^\s]*)\s*=\s*(?P<action>[^$]*)$")
    for line in src_lines:
        line = line.strip()
        if not re_comment.match(line) and not re_blank.match(line ):
            match = re_transition.match(line)
            if match:
                nav_tool.addTransitionFor(match.group('type'), match.group('page'), match.group('outcome'), match.group('action'))
            else:
                sys.stderr.write("Unable to parse '%s' in navigation properties file" % (line))
                    
    out.write('Added Transitions to the Navigation Tool\n\n\n')   


    form_tool = getToolByName( self, 'portal_form')
        
    form_tool.setValidators('docmgtfile_edit_form', ['validate_id', 'validate_docmgtfile_edit'])                
    form_tool.setValidators('docmgtfolder_edit_form', ['validate_id', 'validate_docmgtfolder_edit'])
    form_tool.setValidators('docmgtroot_edit_form', ['validate_id', 'validate_docmgtroot_edit'])
        
    out.write('Added Form Validators to the Form Tool\n')
    
    
    install_tools(self, out)
    
    out.write('Installation Finished\n')
            
    return out.getvalue()



    
