#################################s#o#q######################################

from zLOG import LOG, WARNING, BLATHER, INFO
from OFS.ObjectManager import ObjectManager

from Products.CMFCore.CMFCorePermissions import AddPortalContent, ManagePortal
from Products.CMFCore.DirectoryView import registerDirectory
from Products.CMFCore import utils
from config import *

import DocMgtRoot
import DocMgtFolder
import DocMgtFile
import CMFDocMgtTool
import DocMgtRootPermissions
import DocMgtFolderPermissions
import DocMgtFilePermissions

from ZClasses import createZClassForBase

bases = ( DocMgtRoot.DocMgtRoot, DocMgtFolder.DocMgtFolder, DocMgtFile.DocMgtFile, )

import sys
this_module = sys.modules[ __name__ ]

for base in bases:
    createZClassForBase( base, this_module )

# Make the skins available as DirectoryViews
#registerDirectory( 'skins', globals() )
#registerDirectory( 'skins/soq_docmgt', globals() )
registerDirectory(SKINS_DIR, docmgt_globals)
registerDirectory(SKINS_CONTENT_DIR, docmgt_globals)


tools = (CMFDocMgtTool.CMFDocMgtTool,)

factory_type_information = (
                                DocMgtRoot.factory_type_information 
                                +  DocMgtFolder.factory_type_information 
                                +  DocMgtFile.factory_type_information
                                )
constructors = (
                                DocMgtRoot.addDocMgtRoot
                                ,DocMgtFolder.addDocMgtFolder
                                ,DocMgtFile.addDocMgtFile
                                ,)
contentTypes= (
                                DocMgtRoot.DocMgtRoot
                                ,DocMgtFolder.DocMgtFolder
                                ,DocMgtFile.DocMgtFile
                                ,)


############ override default functions ################

def getid(id):
    if callable(id): return id()
    return id

    
def MN_check_lock(self):
    
    if hasattr(self, "_check_lock"):
        self._check_lock()
    

def MN_setOb(self, id, object):
    try:
        self._dm_check()
    except CMFDocMgt.CMFDocMgtLockException:
        o = []
        ##
        ## Could this go wrong if there already is an object with id? 
        ## (replacable?) (check using getattr?)
        if not hasattr(self, id):
            for i in self._objects:
                if i['id'] != id:
                    o.append(i)
            self._objects = tuple(o)
        raise
    result = self._mo_setOb(id, object)
    #if hasattr(self, 'addRev'):
    #    self.addRev()
    return result

def MN_delOb(self, id):
    obj = getattr(self, id)
    
    self._dm_check() 

    #if hasattr(self, 'removeRev'):
    #    self.removeRev()
    #    
    return self._mo_delOb(id)


from OFS.Image import File, Image

def MN_file_update_data(self, data, content_type=None, size=None):
    #if not hasattr(self, "data"):
    #    oldsize = 0
    #else:
    #    oldsize = self.get_size()

    if hasattr(self, "_dm_check"):
        self._dm_check()

    result = apply(self._mo_update_data, (data, content_type, size))
    
    # the revision is added in DocMgtFile.py since I need log message there
    
    #newsize = self.get_size()

    
    return result


##
## Install all hooks
##
##
## save 'old' methods
LOG('CMFDocMgt', INFO, 'Detected server restart')
ObjectManager._mo_setOb = ObjectManager._setOb
ObjectManager._mo_delOb = ObjectManager._delOb
File._mo_update_data = File.update_data
Image._mo_update_data = Image.update_data


ObjectManager._dm_check = MN_check_lock
ObjectManager._setOb = MN_setOb
ObjectManager._delOb = MN_delOb
File.update_data = MN_file_update_data
Image.update_data = MN_file_update_data

############ override default functions ################

def initialize( context ):

    utils.ToolInit(PROJECTNAME + " Tool", tools=tools,
                   product_name=PROJECTNAME,
                   icon='tool.gif',
                   ).initialize(context)

    ## CMF Initializers
    utils.ContentInit( 'CMFDocMgt'
               , content_types = contentTypes
               , permission = AddPortalContent
               , extra_constructors = constructors
               , fti = factory_type_information
               ).initialize( context )


    #content_types, constructors, ftis = process_types(
    #    listTypes(PROJECTNAME),
    #    PROJECTNAME)
    
    #utils.ContentInit(
    #    PROJECTNAME + ' Content',
    #    content_types      = content_types,
    #    permission         = ADD_CONTENT_PERMISSION,
    #    extra_constructors = constructors,
    #    fti                = ftis,
    #    ).initialize(context)
    
